////////////////////////////////////////////////////////////////////
// routingGraph.h : Class that describes a generic routing graph.
// Copyright (C) 2005 Akshay Sharma, Scott Hauck, and the
// University of Washington.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// The GNU General Public License can be found at 
// http://www.gnu.org/licenses/gpl.txt
/////////////////////////////////////////////////////////////////////

#ifndef RGRAPH_H
#define RGRAPH_H

#include "routingNode.h"
#include "routingEdge.h"

class routingGraph{
 public:
  list<routingNode*> rnodeList;
  vector<routingNode*>* rnodeVector;
  vector<routingNode*>* sourceNodeVector;
  vector<routingNode*>* sinkNodeVector;
  vector<routingNode*>* outputPinNodeVector;
  vector<routingNode*>* inputPinNodeVector;
  vector<routingNode*>* wireNodeVector;
  map<string,routingNode*> rnodeMap;

  long int numNodes,numSourceNodes,numSinkNodes,numInputPinNodes,numOutputPinNodes,numWireNodes;
  long int numDirEdges;

  routingGraph(){
    numDirEdges=0;
    numNodes=numSourceNodes=numSinkNodes=numInputPinNodes=numOutputPinNodes=numWireNodes=0;
    rnodeVector=sourceNodeVector=sinkNodeVector=outputPinNodeVector=inputPinNodeVector=wireNodeVector=0;
  }

  void addto_rnodeList(routingNode* r);
  routingNode* found_routingNode(char* rname);
  void print_info();
  void calculateNodeTypes();
  void createNodeVectors();

};

#endif
